#!/usr/bin/python
#
###########
#
#Name:8_bit_python_counter.py
#Description:LED 8bit binary counter
#Date: Feb. 16, 2019
#Revision:1.0
#Author: Sean D. Conway
#Credit: https://rpi.science.uoit.ca/lab/binary/
###########

import RPi.GPIO as GPIO  # provides interface to input/output pins of the Pi
import time

#initialize variables
bit0 = 3    #assign board pin to binary bit
bit1 = 5
bit2 = 7
bit3 = 29
bit4 = 31
bit5 = 26
bit6 = 24
bit7 = 21
count = 0

# setup GPIO
GPIO.setwarnings(False)
GPIO.setmode(GPIO.BOARD)  # set option to reference physical pins
GPIO.setup(bit0, GPIO.OUT) #initialize pins as outputs
GPIO.setup(bit1, GPIO.OUT)
GPIO.setup(bit2, GPIO.OUT)
GPIO.setup(bit3, GPIO.OUT)
GPIO.setup(bit4, GPIO.OUT)
GPIO.setup(bit5, GPIO.OUT)
GPIO.setup(bit6, GPIO.OUT)
GPIO.setup(bit7, GPIO.OUT)

try:
    while True:
        count = (count + 1) % 255                   # count to 255 then reset to 0
        GPIO.output(bit0, (count >> 0) & 1)  # test binary bit value of variable count, make high if 1
        GPIO.output(bit1, (count >> 1) & 1)
        GPIO.output(bit2, (count >> 2) & 1)
        GPIO.output(bit3, (count >> 3) & 1)
        GPIO.output(bit4, (count >> 4) & 1)
        GPIO.output(bit5, (count >> 5) & 1)
        GPIO.output(bit6, (count >> 6) & 1)
        GPIO.output(bit7, (count >> 7) & 1)
        time.sleep(.1)

except KeyboardInterrupt:  # if ctrl+c pressed exit cleanly
    GPIO.cleanup()
except:  # this catches ALL other exceptions including errors.
    GPIO.cleanup()
finally:  # cleanup GPIO on normal exit
    GPIO.cleanup()
